<?php

// If this file is called directly, abort.
if (!defined('FLC_BASEPATH')) {
    die;
}

class FLC_AddOnsPage {

    use FLC_Singleton;

    public function pageHTML() {

        $messages = apply_filters('flc.add-ons.messages', array());

        $current_tab = isset($_GET['tab']) ? $_GET['tab'] : 'installed';

        $tabs = array(
            'installed' => __('Installed', 'flc-forma-lms-connector')
        );

        add_action('flc.addons.tab-installed', function() {
            
            $addons = FLC_Plugin::instance()->addons();
            $alternate = 0;
            ?>
<table id="installed-addons" class="widefat fixed" cellspacing="0">
    <thead>
        <tr>
            <th class="manage-column column-name" scope="col"><?php _e('Add-on', 'flc-forma-lms-connector'); ?></th>
            <th class="manage-column column-code" scope="col"><?php _e('Code', 'flc-forma-lms-connector'); ?></th>
            <th class="manage-column column-version" scope="col"><?php _e('Version', 'flc-forma-lms-connector'); ?></th>
            <th class="manage-column column-status" scope="col"><?php _e('Status', 'flc-forma-lms-connector'); ?></th>
        </tr>
    </thead>
    <tfoot>
        <tr>
            <th class="manage-column column-name" scope="col"><?php _e('Add-on', 'flc-forma-lms-connector'); ?></th>
            <th class="manage-column column-code" scope="col"><?php _e('Code', 'flc-forma-lms-connector'); ?></th>
            <th class="manage-column column-version" scope="col"><?php _e('Version', 'flc-forma-lms-connector'); ?></th>
            <th class="manage-column column-status" scope="col"><?php _e('Status', 'flc-forma-lms-connector'); ?></th>
        </tr>
    </tfoot>
    <tbody>
    <?php if(count($addons)): ?>
        <?php foreach($addons as $addon): ?>
        <tr class="<?php if($alternate = 1 - $alternate): ?>alternate<?php endif; ?><?php do_action($addon . '.row'); ?>">
            <td class="column-name"><?php do_action($addon . '.title'); ?></td>
            <td class="column-code"><?php do_action($addon . '.code'); ?></td>
            <td class="column-version"><?php do_action($addon . '.version'); ?></td>
            <td class="column-status"><?php do_action($addon . '.status'); ?></td>
        </tr>
        <?php endforeach; ?>
    <?php else: ?>
        <tr class="alternate">
            <td colspan=3><?php _e('No add-on installed.', 'flc-forma-lms-controller'); ?></td>
        </tr>
    <?php endif; ?>
    </tbody>
</table>
            <?php
        });

        ?>
<div class="wrap">
    <h1 style="display: none;"><?php _e('Add-ons', 'flc-forma-lms-connector'); ?></h1><!-- required for notices -->
    <?php echo implode('', $messages); ?>
    <nav class="nav-tab-wrapper woo-nav-tab-wrapper">
    <?php foreach($tabs as $tab => $label): ?>
        <a href="<?php echo admin_url("admin.php?page=flc-addons&tab=$tab"); ?>" class="nav-tab<?php if($current_tab === $tab): ?> nav-tab-active<?php endif; ?>"><?php echo $label ?></a>
    <?php endforeach; ?>
    </nav>
    <?php do_action("flc.addons.tab-$current_tab") ?>
</div>
<style type="text/css">
    #installed-addons input::placeholder {
        color: #CCCCCC;
    }

    #installed-addons tr.warning td {
        background-color: rgba(202, 74, 31, 0.1);
    }

    #installed-addons tr.warning td:first-of-type {
        border-left: 4px solid rgb(202, 74, 31);
    }

    #installed-addons td {
        vertical-align: middle;
    }

    #installed-addons td.column-status div {
        display: inline-block;
    }

    #installed-addons td.column-status div.flc-status {
        line-height: 28px;
        margin-right: 1em;
        text-align: center;
        box-sizing: border-box;
    }

    div.notice p span.add-on {
        margin-right: 1em;
        padding-right: 1em;
        border-right: 1px solid #CCCCCC;
        font-weight: bold;
    }
</style>
        <?php
    }
}
