<?php

// If this file is called directly, abort.
if (!defined('FLC_BASEPATH')) {
    die;
}

class FLC_Settings {

    use FLC_Singleton;

    private $settings = array();
    protected $prefix = 'flc_';

    public function get($setting, $default = null) {

        if(!array_key_exists($setting, $this->settings)) {
            $this->settings[$setting] = get_option($this->prefix . $setting, $default);
        }

        return $this->settings[$setting];
    }

    public function set($setting, $value) {

        if(update_option($this->prefix . $setting, $value)) {
            $this->settings[$setting] = $value;
        }
    }

    public function clear($setting = null) {

        if($setting) {
            delete_option($this->prefix . $setting);
        } else {
            foreach(wp_load_alloptions() as $setting => $value) {
                if(strpos($setting, $this->prefix) === 0 ) {
                    delete_option($setting);
                }
            }
        }
    }

    public function prefix() {

        return $this->prefix;
    }
}
