<?php

// If this file is called directly, abort.
if (!defined('FLC_BASEPATH')) {
    die;
}

class FLC_SSO {

    use FLC_Singleton;
    
    protected $key = '';

    protected function __construct() {
        
        $this->key = FLC_Settings::instance()->get('sso_key', $this->key);
    }

    public function getKey() {

        return $this->key;
    }

    public function execute() {
            
        $redirect = $_GET['redirect'] ? $_GET['redirect'] : null;
        
        if(!is_user_logged_in()) {
            $self_url = get_permalink();
            if($redirect) {
                $self_url = add_query_arg('redirect', $redirect, $self_url);
            }
            $redirect_url = wp_login_url($self_url);
        } else {
            $user = wp_get_current_user();
            $time = time();
            $address = FLC_FormaLMS::instance()->getAddress();

            $token = md5("$user->user_login,$time,$this->key");

            if (version_compare(FLC_FormaLMS::instance()->getVersion(), "2.0", "<")) {
                    $redirect_url = "$address/appLms/index.php?login_user=$user->user_login&time=$time&token=$token";
            } else {
                    $redirect_url = "$address/index.php?r=adm/homepage/sso&login_user=$user->user_login&time=$time&token=$token";
            }

            if($redirect) {
                $redirect = urlencode($redirect);
                $redirect_url .= "&redirect=$redirect";
            }
        }

        wp_redirect($redirect_url);
        exit;
    }
}
