<?php

// If this file is called directly, abort.
if (!defined('FLC_BASEPATH')) {
    die;
}

class FLC_SSOPage {

    use FLC_Singleton;
    
    protected $page_slug = 'flc-sso';

    protected function __construct() {

        $this->page_slug = FLC_Settings::instance()->get('page_slug', $this->page_slug);
    }

    public function getPageSlug() {

        return $this->page_slug;
    }
    
    public function getPage() {

        $page = get_page_by_path($this->page_slug);
        return $page;
    }
    
    public function addPage() {
        
        wp_insert_post(array(
            'post_title'    => 'forma.lms SSO'
          , 'post_name'     => $this->page_slug
          , 'post_type'     => 'page'
          , 'post_status'   => 'publish'
        ));
    }
    
    public function removePage() {

        $page = $this->getPage();
        wp_delete_post($page->ID, true);
    }
    
    public function permalink() {
        
        return get_permalink($this->getPage());
    }
    
    public function link($target = '_self', $content = null) {
        
        if(!$content) {
            $content = $this->getPage()->post_title;
        }

        $href = $this->permalink();
        
        return "<a href='$href' target='$target'>$content</a>";
    }
}
