<?php

// If this file is called directly, abort.
if (!defined('FLC_BASEPATH')) {
    die;
}

abstract class FLC_Entity {

    use FLC_Singleton;

    const name = 'entity';

    public final function callAPI($api, $params = array()) {

        return FLC_API::instance()->call($api, $params);
    }

    public static final function register($entities) {

        $entities[static::name] = get_called_class();
        return $entities;
    }

    public static function isEnabled() {

        return FLC_Settings::instance()->get('entity-' . static::name . '_enabled', false);;
    }

    public static function settings() {

        add_settings_field(
            FLC_Settings::instance()->prefix() . 'entity-' . static::name . '_enabled'
          , __('Enabled', 'flc-forma-lms-connector')
          , array(get_called_class(), 'enableSettingHTML')
          , 'flc_entity-' . static::name . '_settings'
          , 'flc_entity-' . static::name . '_settings'
        );

        register_setting('flc_entity-' . static::name . '_settings', FLC_Settings::instance()->prefix() . 'entity-' . static::name . '_enabled');
    }

    public static final function enableSettingHTML() {

        $enabled = static::isEnabled();
        ?>
        <input type="checkbox" name="flc_entity-<?php echo static::name; ?>_enabled" value=1 <?php checked($enabled); ?> />
        <?php
    }

    public static function getTitle() {

        return __('Entity', 'flc-forma-lms-connector');
    }

    public static function activation() { }
}
