<?php

// If this file is called directly, abort.
if (!defined('FLC_BASEPATH')) {
    die;
}

class FLC_Entity_SSO extends FLC_Entity {

    const name = 'sso';

    protected function __construct() {

        add_action('template_redirect', array($this, 'execute'));
        add_shortcode('flc.sso.permalink', array($this, 'shortcode_permalink'));
        add_shortcode('flc.sso.link', array($this, 'shortcode_link'));
    }

    public function execute() {

        if(is_page(FLC_SSOPage::instance()->getPageSlug())) {
            FLC_SSO::instance()->execute();
        }
    }
    
    public function shortcode_permalink($atts) {

        $atts = shortcode_atts(array(), $atts, 'flc_sso_permalink');
        return FLC_SSOPage::instance()->permalink();
    }
    
    public function shortcode_link($atts, $content = null) {

        $atts = shortcode_atts(array('target' => '_self'), $atts, 'flc_sso_link');        
        $content = do_shortcode($content);        
        return FLC_SSOPage::instance()->link($atts['target'], $content);
    }

    public static function settings() {

        parent::settings();

        add_settings_field(
            FLC_Settings::instance()->prefix() . 'sso_key'
          , __('Key', 'flc-forma-lms-connector')
          , array(get_class(), 'SSOKeyFieldHTML')
          , 'flc_entity-' . static::name . '_settings'
          , 'flc_entity-' . static::name . '_settings'
        );

        register_setting('flc_entity-' . static::name . '_settings', FLC_Settings::instance()->prefix() . 'sso_key');
    }

    public static function SSOKeyFieldHTML() {
        
        $value = FLC_SSO::instance()->getKey();
        ?>
        <input type="text" name="<?php echo FLC_Settings::instance()->prefix() . 'sso_key'; ?>" value="<?php echo esc_attr($value); ?>" />
        <?php
    }

    public static function getTitle() {

        return __('SSO', 'flc-forma-lms-connector');
    }
}

add_action('flc.register-entity', array('FLC_Entity_SSO', 'register'), 20);
